<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="500px">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="auto"
    >
      <el-form-item label="名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入名称" />
      </el-form-item>
      <el-form-item label="提成比例" prop="percentageRate">
        <el-input v-model="formData.percentageRate" placeholder="请输入比例">
          <template #suffix> % </template>
        </el-input>
      </el-form-item>
      <el-form-item label="负责人" prop="director">
        <el-select
          v-model="formData.director"
          placeholder="选择负责人"
          clearable
          filterable
          style="width: 100%"
        >
          <el-option
            v-for="item in employeeOptions"
            :key="item.id"
            :label="item.nickname"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-row>
        <el-col :span="24" :offset="0">
          <el-form-item label="开始负责时间" prop="startTime">
            <el-date-picker
              v-model="formData.startTime"
              type="date"
              placeholder="选择日期"
              format="YYYY-MM-DD"
              value-format="YYYY-MM-DD"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="备注" prop="remark">
        <el-input
          type="textarea"
          v-model="formData.remark"
          placeholder="请输入备注"
          :autosize="{ minRows: 4, maxRows: 8 }"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script name="DialogArea" setup>
import * as AreaApi from '@/api/school/setting/area'
import { getSimpleUserList } from '@/api/system/user'
const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  name: undefined,
  percentageRate: undefined,
  director: undefined,
  startTime: undefined,
  remark: ''
})
const formRules = reactive({
  name: [{ required: true, message: '名称不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

const employeeOptions = ref([])

/** 打开弹窗 */
const open = async (type, id) => {
  dialogVisible.value = true
  dialogTitle.value = type == 'update' ? '修改区域' : '新增区域'
  formType.value = type
  resetForm()
  getOptions()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await AreaApi.getArea(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    if (formType.value === 'create') {
      await AreaApi.createArea(formData.value)
      message.success(t('common.createSuccess'))
    } else {
      await AreaApi.updateArea(formData.value)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    name: undefined,
    percentageRate: undefined,
    director: undefined,
    startTime: undefined,
    remark: ''
  }
  formRef.value?.resetFields()
}

function getOptions() {
  getSimpleUserList().then((data) => {
    employeeOptions.value = data
  })
}
</script>
